/******************************************************************************/
/*
 *
 * @file edl_functions.c
 *
 * This file custom functions used by BE-CEM-EDL to get extra information
 *
 ******************************************************************************/

/***************************** Include Files **********************************/

#include "crc.h"

/******************************* Functions ************************************/
static uint8_t crc8_byte(uint8_t data)
{
    uint8_t poly = 0x07; /* x^8 + x^2 + x + 1 */
    uint8_t crc = data;
    for (uint8_t i = 0; i < 8; ++i)
            if (crc & 0x80)
                    crc = ((crc << 1) ^ poly);
            else
                    crc = (crc << 1);
    return crc;
}

static uint8_t crc8_byte_notmr(uint8_t data)
{
    uint8_t poly = 0x07; /* x^8 + x^2 + x + 1 */
    uint8_t crc = data;
    for (uint8_t i = 0; i < 8; ++i)
            if (crc & 0x80)
                    crc = ((crc << 1) ^ poly);
            else
                    crc = (crc << 1);
    return crc;
}

static uint8_t crc8_bytearray(uint8_t *data, uint8_t len, uint8_t start_val)
{
    uint8_t result = start_val;
    for (uint8_t i = 0; i < len; ++i) {
            result = crc8_byte_notmr(result ^ data[i]);
    }
    return result;
}

